<?php

// Load settings out of database to overwrite defaults from action_hooks.
$floorplans_db = get_option(FP_ADMIN_OPTION_NAME);

/**
 *
 * System-wide Filters and Settings
 *
 */

// This slug will be used to display properties on the front-end.  Most likely overwriten by get_option('wpp_settings');
$floorplans['configuration'] = array(
'autoload_css' => 'true',
'automatically_insert_overview' => 'true',
'base_slug' => 'floorplan',
'phone_number' => '3013706463',
'currency_symbol' => '$');

// Default setings for [floorplan_overview] shortcode
$floorplans['configuration']['floorplan_overview'] = array(
'thumbnail_size' => 'tiny_thumb',
'fancybox_preview' => 'true',
'display_slideshow' => 'false',
'show_children' => 'true');

// Default setings for [floorplan_overview] shortcode
$floorplans['configuration']['single_floorplan_view'] = array(
'map_image_type' => 'tiny_thumb',
'gm_zoom_level' => '13');



 // Default setings for admin UI
$floorplans['configuration']['admin_ui'] = array(
'overview_table_thumbnail_size' => 'tiny_thumb');

 

// floorplan stats. Can be searchable, displayed as input boxes on editing page.
if(!is_array($floorplans_db['floorplan_stats']))
$floorplans['floorplan_stats'] =  array(
'sqft' => __('Square Ft.','floorplans'),
'price' => __('Price','floorplans'),
'bedrooms' => __('Bedrooms','floorplans'),
'bathrooms' => __('Bathrooms','floorplans'),
'floorplan_type' => __('Style','floorplans'),
'floorplan_collection' => __('Collection','floorplans'),
'video_code' => __('Video Code','floorplans'),
'minwidth' => __('Min. Width','floorplans'),
'garage_location' => __('Garage Location','floorplans'),
'third_floor' => __('3rd Floor','floorplans'),
'sideload_garage' => __('Side Load Garage','floorplans'),
'first_floor_master_suite' => __('1st Floor Master Suite','floorplans'),
'mindepth' => __('Min. Depth','floorplans')
);

if(!is_array($floorplans_db['floorplan_overview_cols']))
$floorplans['floorplan_overview_cols'] =  array(
'sqft' => __('Square Ft.','floorplans'),
'price' => __('Price','floorplans'),
'bedrooms' => __('Bedrooms','floorplans'),
'bathrooms' => __('Bathrooms','floorplans'),
'floorplan_type' => __('Style','floorplans'),
'floorplan_collection' => __('Collection','floorplans'),
'minwidth' => __('Min. Width','floorplans'),
'mindepth' => __('Min. Depth','floorplans')
);

if(!is_array($floorplans_db['floorplan_yesno']))
$floorplans['floorplan_yesno'] =  array(
'garage_location',
'third_floor',
'sideload_garage',
'first_floor_master_suite'
 );
 
/**
 *
 * Searching and Filtering
 *
 */



// Attributes to use in searching.
if(!is_array($floorplans_db['searchable_attributes']))
$floorplans['searchable_attributes'] =  array(
'area',
'bedrooms',
'bathrooms',
'city',
'price',
'floorplan_type',
'floorplan_collection',
'mindepth',
'minwidth'
);

if(!is_array($floorplans_db['searchable_attributes']))
$floorplans['sortable_attributes'] =  array(
'area',
'bedrooms',
'bathrooms',
'city',
'price',
'floorplan_type',
'floorplan_collection',
'mindepth',
'minwidth'
);




if(!is_array($floorplans_db['descriptions']))
$floorplans['descriptions'] =  array(
 'floorplan_type' => __('The style to which a floorplan adheres', 'floorplans'),
);


// Convert phrases to searchable values.  Converts string stats into numeric values for searching and filtering.
if(!is_array($floorplans_db['search_conversions']))
$floorplans['search_conversions'] =array(
'bedrooms' => array(
__('Studio','floorplans') => '0.5'
));


 

/**
 *
 * Display and UI related filters
 *
 */

// Don't load defaults if settings exist in db
if(!is_array($floorplans_db['image_sizes']))
$floorplans['image_sizes'] = array(
'map_thumb' => array('width'=> '75', 'height' => '75'),
'tiny_thumb' => array('width'=> '100', 'height' => '100'),
'sidebar_wide' => array('width'=> '195', 'height' => '130'),
'slideshow' => array('width'=> '640', 'height' => '235')
);


$floorplans['floorplan_type'] = array(
'Classic',
'Craftsman',
'Farmhouse',
'Luxury',
'Rancher'
);
$floorplans['floorplan_collection'] = $floorplans_db['floorplan_collection'];

$floorplans['floorplan_collection'] = array(
'Bannockburn',
'Kenwood',
'Woodacres',
'Edgemoor'
);
$floorplans['floorplan_type'] = $floorplans_db['floorplan_type'];
// Overwrite $floorplans with database setting
$floorplans = FP_UD::array_merge_recursive_distinct($floorplans, $floorplans_db);
 
 
?>