<?php
class FP_Core {
	function FP_Core() {
		global $floorplans, $wp_rewrite;
		
		FP_Utils::settings_action();
		
		
		// Load early so plugins can use them as well
		wp_register_style('jquery-fancybox-css', FP_URL. '/third-party/fancybox/jquery.fancybox-1.3.1.css');
        wp_register_style('jquery-ui', FP_URL. '/css/jquery-ui.css');
		wp_register_script('jquery-fancybox', FP_URL. '/third-party/fancybox/jquery.fancybox-1.3.1.pack.js', array('jquery'), '1.7.3' );
		wp_register_script('jquery-easing', FP_URL. '/third-party/fancybox/jquery.easing-1.3.pack.js', array('jquery'), '1.7.3' );
		wp_register_script('jquery-slider', FP_URL. '/js/jquery.ui.slider.min.js', array('jquery'), '1.7.3' );
 		wp_register_script('jquery-mouse', FP_URL. '/js/jquery.ui.mouse.min.js', array('jquery'), '1.4.3' );
		wp_register_script('jquery-cookie', FP_URL. '/js/jquery.cookie.js', array('jquery'), '1.7.3' );
		wp_register_script('floorplan-admin-overview', FP_URL. '/js/floorplans-admin-overview.js', array('jquery'), '0.63' );
		wp_register_script('floorplans-overview', FP_URL. '/js/floorplans-overview.js', array('jquery'), '0.63' );
		wp_register_script('floorplan-global', fp_URL. '/js/floorplans-global.js', array('jquery'), '0.63' );
 		wp_register_script('google-maps', 'http://maps.google.com/maps/api/js?sensor=true');
		wp_register_script('jquery-quicksand', Fp_URL. '/third-party/jquery.quicksand.js', array('jquery'));
		
		// Find and register stylesheet
		if ( file_exists( TEMPLATEPATH . '/floorplans.css') ) {
			wp_register_style('floorplan-frontend', get_bloginfo('template_url') . '/floorplans.css',   array(),'0.63' );
		} elseif (file_exists( FP_Path . '/template_files/floorplans.css') && $floorplans[configuration][autoload_css] == 'true') {
			wp_register_style('floorplan-frontend', FP_URL . '/template_files/floorplans.css',  array(), '0.63' );
		}
		// Find and register MSIE stylesheet
		if ( file_exists( TEMPLATEPATH . '/floorplan-msie.css') ) {
			wp_register_style('floorplan-frontend-msie', get_bloginfo('template_url') . '/floorplans-msie.css',   array(),'0.63' );
		} elseif (file_exists( FP_Path . '/template_files/floorplans-msie.css') && $floorplans[configuration][autoload_css] == 'true') {
			wp_register_style('flooplan-frontend-msie', FP_URL . '/template_files/floorplans-msie.css',  array(), '0.63' );
		}

		// Find front-end JavaScript and register the script
		if ( file_exists( TEMPLATEPATH . '/floorplans.js') ) {
			wp_register_script('floorplans-frontend', get_bloginfo('template_url') . '/floorplans.js', array(),'0.63' );
 		} elseif (file_exists( FP_Path . '/template_files/floorplans.js')) {
			wp_register_script('floorplans-frontend', FP_URL . '/template_files/floorplans.js', array(), '0.63' );
 		}

		
		$labels = array(
			'name' => __('Floorplans', 'floorplans'),
			'singular_name' => __('Floorplan', 'floorplans'),
			'add_new' => __('Add New', 'floorplans'),
			'add_new_item' => __('Add New Floorplan', 'floorplans'),
			'edit_item' => __('Edit Floorplan', 'floorplans'),
			'new_item' => __('New Floorplan', 'floorplans'),
			'view_item' => __('View Floorplan', 'floorplans'),
			'search_items' => __('Search Floorplans', 'floorplans'),
			'not_found' =>  __('No floorplans found', 'floorplans'),
			'not_found_in_trash' => __('No floorplans found in Trash', 'floorplans'),
			'parent_item_colon' => ''
		);
		
		// Add shortcodes
		add_shortcode('floorplan_overview_page', array(&$this, 'shortcode_floorplan_overview_page'));
		
		// Modify admin body class
		add_filter('admin_body_class', array('FP_Core', 'admin_body_class'));
		
		//Modify Front-end floorplan body class
		add_filter('body_class', array('FP_Core', 'floorplans_body_class'));
		
		register_post_type('floorplan', array(
			'labels' => $labels,
			'singular_label' => __('Floorplan','floorplans'),
			'public' => true,
			'show_ui' => true,
			'_builtin' => false,
			'_edit_link' => 'post.php?post=%d',
			'capability_type' => 'post',
			'hierarchical' => true,
			'rewrite' => array('slug'=>$floorplans['configuration']['base_slug']),
			'query_var' => $floorplans['configuration']['base_slug'],
			'supports' => array('title','editor', 'thumbnail', 'excerpt')
		));
		
		register_sidebar( array(
			'name'=> __('Floorplan Right Sidebar', 'floorplans'),
			'id' => "fp_floorplan_right_sidebar",
			'before_title' => '<h3 class="widget-title">',
			'after_title' => '</h3>',
		));
		
		register_sidebar( array(
			'name'=> __('Floorplan Top Row', 'floorplans'),
			'id' => "fp_floorplan_top_row",
			'before_title' => '<h3 class="widget-title">',
			'after_title' => '</h3>',
		));
		
		register_sidebar( array(
			'name'=> __('Floorplan Bottom Row', 'floorplans'),
			'id' => "fp_floorplan_bottom_row",
			'before_title' => '<h3 class="widget-title">',
			'after_title' => '</h3>',
		));
		
		register_taxonomy( 'floorplan_feature', 'floorplan', array(
             'hierarchical' => false,
             'label' => __('Floorplan Features','floorplan'),
             'query_var' => 'floorplan_feature',
             'rewrite' => array('slug' => 'feature' )
        ));
		
		add_action('wp_ajax_fp_ajax_floorplan_query', create_function("",' $class = FP_Utils::get_floorplan($_REQUEST["floorplan_id"]); if($class)  print_r($class); else echo __("No floorplan found.","floorplans"); die();'));
		
		//Ajax pagination for property_overview
 		add_action("wp_ajax_fp_floorplan_overview_pagination", array($this, "ajax_floorplan_overview"));
        add_action("wp_ajax_nopriv_fp_floorplan_overview_pagination", array($this, "ajax_floorplan_overview"));
		
		//foreach($floorplans['image_sizes'] as $image_name => $image_sizes)
			//add_image_size($image_name, $image_sizes['width'], $image_sizes['height'], true);
		
		add_action('the_post', array('FP_Utils','the_post'));

		// Register custom taxonomy
		//register_taxonomy("speaker", array("podcast"), array("hierarchical" => true, "label" => __('Speakers','floorplans'), "singular_label" => __('Speaker','floorplans'), "rewrite" => true));

		add_action("the_content", array(&$this, "the_content"));
		
		register_taxonomy_for_object_type('floorplan_features', 'floorplan');
		
		add_action("template_redirect", array(&$this, 'template_redirect'));
		
		/* admin stuff */
		add_action("admin_init", array(&$this, "admin_init"));
		add_action('admin_print_styles', array(&$this, 'insert_admin_styles'), 1);
		add_action('admin_print_scripts', array(&$this, 'insert_admin_scripts'), 1);
		add_action('admin_menu', array(&$this, 'add_to_menu'));
		add_action('save_post', array(&$this, 'save_floorplan'));
		add_filter("manage_edit-floorplan_columns", array(&$this, "edit_columns"));
		add_action("manage_pages_custom_column", array(&$this, "custom_columns"));
		add_filter("parse_query", array($this, "fix_404"));
		$wp_rewrite->flush_rules();
	}
	
	function insert_admin_styles() {
		global $current_screen;
		//wp_register_style('fp-admin-styles', content_url() . '/floorplans/css/admin_styles.css');
		//wp_enqueue_style('fp-admin-styles');
		wp_register_style('floorplansAdmin', FP_URL . '/css/floorplans_admin.css');
		wp_enqueue_style('floorplansAdmin');
	}
	
	function insert_admin_scripts() {
		
	}
	
	function floorplans_body_class($classes){
		global  $post, $floorplans;
		
		if(strpos($post->post_content, "floorplan_overview") || (is_search() && isset($_REQUEST['fp_search'])) || ($floorplans['configuration']['base_slug'] == $post->post_name) ) {
    		$classes[] = 'wp-floorplan-listing';
		}
		return $classes;	
    }
	
	function the_content($content) {
		global $post, $floorplans;

		if(empty($floorplans['configuration']['base_slug']))
			return $content;

		if($floorplans['configuration']['base_slug'] == $post->post_name && $floorplans['configuration']['automatically_insert_overview'] == 'true')
			return FP_Core::shortcode_floorplan_overview();

		return $content;
	}
	
	function admin_body_class($content) {
		global $current_screen;


		if($current_screen->id == 'edit-floorplan') {

			return 'fp_overview';
		}

		if($current_screen->id == 'floorplan') {

			return 'fp_floorplan_edit';
		}



	 }
	 
	 function fix_404($query) {
		global $wp_query, $floorplans;

		if(empty($floorplans['configuration']['base_slug']))
			return;


		if($query->query_vars[name] == $floorplans['configuration']['base_slug']) {
			$query->is_search = true;
		}

 	}
	
	function add_to_menu() {
		$settings_page =  add_submenu_page('edit.php?post_type=floorplan', __('Settings', 'floorplans'), __('Settings', 'floorplans'), 9, 'floorplan_settings', create_function('','global $floorplans; include "ui/page_settings.php";'));	
		add_action('admin_print_scripts-' . $settings_page, create_function('', "wp_enqueue_script('jquery-ui-tabs');wp_enqueue_script('jquery-cookie');wp_enqueue_script('floorplan-admin-overview');"));
		add_action('admin_head-edit.php', array("FP_Core", "overview_page_scripts"));
	}
	
	function overview_page_scripts() {
		global $current_screen, $wp_properties;

		switch ($current_screen->id) {

			// Property Overview Page
			case 'edit-floorplan':

				// If settings not configured
				if(get_option(FP_ADMIN_OPTION_NAME) == ""):

				$default_url =  FP_UD::base_url($floorplans['configuration']['base_slug']);
				$settings_page =  admin_url('edit.php?post_type=floorplan&page=floorplan_settings');
				$permalink_problem = (get_option('permalink_structure') == '' )
					? sprintf(__('Be advised, since you don\'t have permalinks enabled, you must visit the <a href="%s">Settings Page</a> and set a custom property overview page.', 'wpp'), $settings_page)
					: sprintf(__('By default, your property overview will be displayed on the <a href="%s">%s</a> page. You may change the overview page on the <a href="%s">Settings Page</a>', 'wpp'), $default_url, $default_url, $settings_page);
				?>

				<script type="text/javascript">
					jQuery(document).ready(function() {

						var message = "<div class='updated fade'>" +
							"<p><b><?php _e('Thank you for installing Floorplans!','floorplans') ?></b> " +
							"<?php echo $permalink_problem; ?></p>";
							
 						jQuery(message).insertAfter(".fp_overview  h2");
					});
				</script>

			<?php endif;

			break;

			case 'property':
			// Property Editing Page
			break;
		}
	}
	
	function after_setup_theme() {
		add_theme_support( 'post-thumbnails' );
		add_image_size( 'tiny_thumb', 100, 100 );
	}
	
	function admin_init() {
	    add_meta_box( 'floorplan_meta', __('General Information','floorplans'), array('FP_Floorplan_UI','metabox_meta'), 'floorplan', 'normal' );
 	}
	
	function template_redirect() {
		global $post, $floorplan, $wp, $wp_query, $floorplans, $wp_styles;
		// Prepare MSIE css to load on MSIE only
		$wp_styles->add_data( 'floorplan-frontend-msie', 'conditional', 'lte IE 7' );

		// Call on all pages because styles are used in widgets
		wp_enqueue_style('floorplan-frontend');

		// Loaded only on MSIE
		wp_enqueue_style('floorplan-frontend-msie');

		// Include template functions
		//include fp_Templates . "/template-functions.php";
		include FP_Path . "/template_files/template-functions.php";
		
		
		$is_search = (is_array($_REQUEST[wpp_search]) ? true : false);


		if($wp->request == $floorplans['configuration']['base_slug'] || $wp->query_string == "p=" . $floorplans['configuration']['base_slug'] || strpos($post->post_content, "floorplan_overview_page"))
			$overview_page = true;
		// Scripts for both types of views
		//if ($single_page || $overview_page)	{
			wp_enqueue_script('jquery-ui-slider', FP_URL . '/js/jquery.ui.slider.min.js', array('jquery-ui-core'), '1.7.2' );
			if (!$overview_page) {
				wp_enqueue_script('jquery-fancybox');
				wp_enqueue_script('floorplans-frontend');
				wp_enqueue_style('jquery-fancybox-css');
				
				wp_enqueue_script('jquery-ui-slider', WPP_URL . '/js/jquery.ui.slider.min.js', array('jquery-ui-core'), '1.7.2' );
				wp_enqueue_script('jquery-fancybox');
				wp_enqueue_script('floorplans-frontend');

				wp_enqueue_style('jquery-fancybox-css');
           		wp_enqueue_style('jquery-ui');
			} else {
				wp_enqueue_script('floorplans-overview');	
			}
           	wp_enqueue_style('jquery-ui');

		//}
		
		if($post->post_type == "floorplan") {
			load_template( FP_Path.'/template_files/floorplan.php' );
			exit;
		}
	}
	
	function ajax_floorplan_overview()  {
        include_once FP_Path . "/template_files/template-functions.php";
        
        $params = $_REQUEST;
        if(!empty($params['action']))
        	unset($params['action']);
        	
        if(!empty($params['pagination']))
        	unset($params['pagination']);

       // $params['ajax_call'] = true;
		
		$data = FP_Core::shortcode_floorplan_overview_page($params);

		echo $data;
        die();
	}
	
	function save_floorplan($post_id) {
		global $wp_rewrite, $floorplans;

		if (!wp_verify_nonce( $_POST['_wpnonce'],'update-floorplan_' . $post_id))
			return $post_id;

		//if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE )
		//	return $post_id;
		$update_data = $_REQUEST['floorplan_data']['meta'];
		//print_r($update_data);
		foreach($update_data as $meta_key => $meta_value) {

			//Remove certain characters
			if($meta_key == 'price')
				 $meta_value = str_replace("$" , '', $meta_value);
			//echo $meta_value;
			update_post_meta($post_id, $meta_key, $meta_value);
 		}

		//$wp_rewrite->flush_rules();

		return true;
 	}

	function edit_columns($columns) {
		global $floorplans;

		unset($columns);
		$columns['cb'] = "<input type=\"checkbox\" />";
		$columns['title'] = __('Title','floorplans');
		$columns['floorplan_type'] = __('Style','floorplans');
		$columns['floorplan_collection'] = __('Collection','floorplans');
		$columns['price'] = __('Price','floorplans');
		$columns['bedrooms'] = __('Bedrooms','floorplans');
		$columns['bathrooms'] = __('Bathrooms','floorplans');
		$columns['sqft'] = __('Sq. Ft.','floorplans');
		$columns['thumbnail'] = __('Thumbnail','floorplans');
		return $columns;
	}

	function custom_columns($column) {
		global $post, $floorplans;
		//if ($post->post_type != 'floorplan') return;
		switch ($column) {
			case "description":
				the_excerpt();
			break;
			
			case "floorplan_type":
				$i = get_post_meta($post->ID, $column, true);
				echo $floorplans['floorplan_type'][$i];
			break;
			
			case "floorplan_collection":
				$i = get_post_meta($post->ID, $column, true);
				echo $floorplans['floorplan_collection'][$i];
			break;
			
			case "sqft":
				echo apply_filters('fp_stat_filter_area', get_post_meta($post->ID, $column, true));
			break;
			
			case "price":
				echo apply_filters('fp_stat_filter_price', get_post_meta($post->ID, $column, true));
			break;
			
			case "thumbnail":
				$image_thumb_url = $post->images[$floorplans[configuration][admin_ui][overview_table_thumbnail_size]];
				if(!empty($image_thumb_url)) {
				?>
					<a href="<?php echo $post->images[large]; ?>" class="fancybox" rel="overview_group" title="<?php echo  $post->post_title; ?>">
						<img src="<?php echo $image_thumb_url; ?>" />
					</a>

				<?php
				} else {
					//echo " - ";
				}

			break;

			default:
				echo get_post_meta($post->ID, $column, true);
			break;


		}
	}

	function shortcode_floorplan_overview_page($atts = "")  {
		global $floorplans;
		$default_floorplan_type = FP_Utils::get_most_common_floorplan_type();

        // convert all saved attributes into useful array
        foreach($floorplans['floorplan_stats'] as $k => $v)
            $to_use[$k] = '';

        if(empty($atts))
            $atts['type'] = 'all';
        $to_use['per_page'] = '10';
        $to_use['starting_row'] = '0';

        // merge with specified by user
        $fp_atts = array_merge($to_use, $atts);
		//var_dump($fp_atts);
        $query = ''; // get the query string from an array with not empty values
        foreach($fp_atts as $attr => $value){
            if ($value != '') {
                if ($attr == 'type') $attr = 'floorplan_type'; // need this for better UI and to avoid mistakes
                if ($attr == 'per_page') {$per_page = $value; continue; }
                if ($attr == 'starting_row') {$offset = $value; continue; }
                if ($attr == 'sorter') {$sorter = $value; continue; }
                if ($attr == 'ajax_call') {$ajax_call = $value; continue; }
                if ($attr != 'filters')
			    	$query .= $attr.'='.$value;
				else
					$query .= $value;
                if (end($fp_atts) !== $value) $query .= '&';
            }
        }
		
		$sorter = 1;
        // default values not used for getting floorplans
        extract(array(
            'show_children'             => 'true',
            'child_floorplans_title'    => __('Floor plans at location:','floorplans'),
            'fancybox_preview'          => $floorplans['configuration']['floorplan_overview']['fancybox_preview'],
            'thumbnail_size'            => $floorplans['configuration']['floorplan_overview']['thumbnail_size'],
            'ajax_call'                 => false,
            'sort_by'                   => ($fp_atts['sort_by'])?$fp_atts['sort_by']:'menu_order',
            'sort_order'                => ($fp_atts['sort_order'] && (strtoupper($fp_atts['sort_order']) == 'ASC' || strtoupper($fp_atts['sort_order']) == 'DESC'))? strtoupper($fp_atts['sort_order']):'ASC'
        ));

 		// Get image sizes for overview/search page
		$thumbnail_sizes = FP_Utils::image_sizes($thumbnail_size);
		
		$sortable_attrs = array();
                if (!empty($floorplans['floorplan_stats']) && $floorplans['sortable_attributes']) {
                    foreach ($floorplans['floorplan_stats'] as $slug => $label) {
                        if(in_array($slug, $floorplans['sortable_attributes'])) {
                            $sortable_attrs[$slug] = $label;
                        }
                    }
                    //If default ORDER_BY attr doesn't exist in sortable attributes we set ORDER_BY by first sortable attribute.
                    if(!empty($sortable_attrs) && !in_array($sort_by, $floorplans['sortable_attributes'])) {
                        $sort_by = key($sortable_attrs);
                    }
                }
		//print_r($sortable_attrs);
		if(empty($fp_atts['ajax_call'])) {
            if(!isset($_REQUEST['fp_search'])){ // NOT SEARCH - usual use via shortcode
                //$total = count(FP_Utils::get_floorplans($query));
		        $query .= '&pagi='.$offset.'--'.$per_page; // get back limits per page
		        $query .= '&sort_by='.$sort_by;
                $floorplan_objects = FP_Utils::get_floorplans($query);
                $total = $floorplan_objects['total'];
                unset($floorplan_objects['total']); // VERY IMPORTANT!!!
            }else{ // SEARCH RESULTS
                // get rid of empty data that are not inputed by user in search form
                foreach($_REQUEST['fp_search'] as $k => $v){
                    if(is_array($v) && !empty($v['checked'])) {
                        $searchable_attributes[$k] = 'true';
                    } 
                    elseif (is_array($v) && $k == 'floorplan_type'){
                		$searchable_attributes[$k] = $v;
                	}
                    elseif(($v['min']=='' || $v['min']=='0' || $v['min']=='-1') && $v['max']=='' )
                        continue;
                    else
                        $searchable_attributes[$k] = $v;
                }

                $query = ''; // now we need to form a query string that will get found floorplans
                if(isset($searchable_attributes)){
                    foreach($searchable_attributes as $attr => $value){
                        if($attr == 'floorplan_type'){
                        $query .= $attr.'=';
                        $count = count($value);
                               for($i=0; $i<$count; $i++){
                                $query .= $value[$i].',';
                               }
                        $query = (substr($query, -1, 1) == ',') ? substr_replace($query,'', -1, 1) : $query;
                        }elseif(is_array($value)){
                            $query .= $attr.'='.$value['min'].'-'.$value['max'];
                        }else{
                            if($value=='-1') continue;
                            if($attr == 'pagi') {
                                $pagi = '&'.$attr.'='.$value;
                                $limits = explode('--', $value);
                                $starting_row = $limits[0];
                                $per_page = $limits[1];
                                continue;
                            }
                            $query .= $attr.'='.$value;
                        }
                        if(end($searchable_attributes) !== $value) $query .= '&';
                    }
                }
                $query = (substr($query, -1, 1) == '&') ? substr_replace($query,'', -1, 1) : $query;
                $query .= $pagi;
                $floorplan_objects = FP_Utils::get_floorplans($query);
                $total = $floorplan_objects['total'];
                unset($floorplan_objects['total']); // VERY IMPORTANT!!!
               
            } // end isset($_REQUEST['fp_search']

           ob_start();
               if(file_exists(TEMPLATEPATH . "/floorplan-pagination.php")) {
                    include TEMPLATEPATH . "/floorplan-pagination.php";
                }elseif(file_exists(FP_Path . "/template_files/floorplan-pagination.php")) {
                    include FP_Path . "/template_files/floorplan-pagination.php";
                }
            $result .= ob_get_contents();
            ob_end_clean();
		}else{ // !empty($fp_atts['ajax_call'])
            $query .= '&pagi='.$offset.'--'.$per_page;
			//echo '<BR>'.$query;
            $floorplan_objects = FP_Utils::get_floorplans($query);
        }

        // Set value to false if nothing returned.
		if(!is_array($floorplan_objects))
            $floorplan_objects = false;

		// Convert variables to booleans
		$ajax_call          = ($ajax_call == 'true' ? true : false);
		$show_children 		= ($show_children == 'true' ? true : false);
		$fancybox_preview   = ($fancybox_preview == 'true' ? true : false);

		ob_start();
	if(file_exists(TEMPLATEPATH . "/floorplan-overview.php")) {
				include TEMPLATEPATH . "/floorplan-overview.php";

		// 4. If all else fails, try the default general template
			}elseif(file_exists(FP_Path . "/template_files/floorplan-overview.php")) {
				include FP_Path . "/template_files/floorplan-overview.php";
			}

		$result .= ob_get_contents();
		ob_end_clean();

		return $result;
	}
}
?>