<?php
/*
Plugin Name: Floorplans
Plugin URI: http://paramountconstruction.net
Description: Display floorplans on your website.
Author: Paramount Construction
Version: 0.2
Author URI: http://paramountconstruction.net
*/

define('FP_ADMIN_OPTION_NAME', 'floorplans_option');

define('FP_Path', WP_PLUGIN_DIR . '/floorplans');
define('FP_URL', WP_PLUGIN_URL . '/floorplans');
define('FP_Templates', WP_PLUGIN_URL . '/floorplans/template_files');


define('UD_UI_PREFIX', 'fp_');
define('UD_PREFIX', 'fp_');

function fp_load_textdomain() {
	$locale = get_locale();
	$mofile = FP_PATH . "/langs/wpp-$locale.mo";

	if ( file_exists( $mofile ) )
		load_textdomain( 'fp', $mofile );
}

add_action ( 'plugins_loaded', 'fp_load_textdomain', 2 );
require_once('core/class.ud.php');
require_once('action_hooks.php');
require_once('template_files/class.api.php');
new FP_API(); // Setup API filters
require_once('core/class.utils.php');
register_activation_hook(__FILE__,array('FP_Utils', 'activation'));
require_once('core/class.widgets.php');
require_once('core/ui/class.floorplan_ui.php');
require_once('core/class.core.php');

add_action('widgets_init', create_function('', 'return register_widget("GalleryFloorplansWidget");'));
add_action('widgets_init', create_function('', 'return register_widget("FloorplanFeaturesWidget");'));
add_action('widgets_init', create_function('', 'return register_widget("FloorplanVideoWidget");'));
add_action('widgets_init', create_function('', 'return register_widget("FloorplanStatsWidget");'));
add_action('init', create_function('', 'new FP_Core();'));

?>