<?php 
/**
 * WP-floorplan Overview Pagination (Sorter) Block Template
 *
 * To customize this file, copy it into your theme directory, and the plugin will
 * automatically load your version.
 *
 * You can also customize it based on floorplan type.
 *
*/
?>
	<script type="text/javascript">
		function make_pagination() {
			var query = '<?php echo $query; ?>';
			//alert(query);
			var pagination_div = jQuery('#floorplans_pagination');
			var out = '<a class="nav prev disabled" href="javascript:;"><?php _e('Prev'); ?> -</a><ul>';
			var total = '<?php echo $total; ?>';
			var per_page = '<?php echo $per_page; ?>';
			var page_number = 0;
			for (var i = 0; i < total; i++) {
				if (i % per_page == 0) {
					++page_number;
					pg = (page_number == 1) ? 'selected' : '';
					out = out + '<li><a href="javascript:;" class="page_button ' + pg + '" id="' + i + '">' + page_number + '</a></li>';
				}
			}
		   out = out + '</ul> <a class="nav next" href="javascript:;">- <?php _e('Next'); ?></a>';
		   //alert(out);
		   jQuery('#floorplans_pagination').html(out);
		}
	</script>
    <div class="floorplans-handling">
     &nbsp;&nbsp;&nbsp;
        <!--<div id="ajax_loader"></div>-->
    <?php
        if(substr_count($query, 'pagi') && ($total > $per_page) ){ ?>
            <div id="floorplans_pagination">
                
            </div>
            <div class="clear"></div>
    <?php }
        if(!empty($sorter) && !empty($sortable_attrs)) : ?>
			
            <form id="floorplans_sorter" action="">
                <label for="sort_by"><?php _e('Order By:','floorplans') ?></label>
                <select name="sort_by" id="sort_by">
                    <?php foreach($sortable_attrs as $slug => $label) : ?>
                    <option value="<?php echo $slug; ?>" <?php echo ($sort_by == $slug)?'selected="selected"':''; ?>><?php echo $label; ?></option>
                    <?php endforeach; ?>
                </select>
                <div id="sort_order" class="<?php echo (!empty($sort_order)?$sort_order:'ASC'); ?>"></div>
                <div class="clear"></div>
				<!--<p><a class="init_filters" href="javascript:void(0)"><?php _e("Refine Floorplan Results", 'floorplans'); ?> (<span>+</span>)</a></p>-->
            </form>
        <?php endif; ?>
        <div id="floorplan_filters">
        	<p><?php _e("Use the following options to filter your floorplans accordingly.", 'floorplans'); ?></p>
			<ul>
            	<li><?php _e("This Floorplan Style Only:", 'floorplans'); ?> 
                <select name="floorplan_type">
                <option value="all">All</option>
                <?php foreach($floorplans['floorplan_type'] as $slug => $label): ?> 
                	<option value="<?php echo $slug; ?>"><?php echo $label; ?></option>
                <?php endforeach; ?>
                </select></li>
        		<li><?php _e("This Collection Only:", 'floorplans'); ?> 
                <select name="floorplan_collection">
                <option value="all">All</option>
                <?php foreach($floorplans['floorplan_collection'] as $slug => $label): ?> 
                	<option value="<?php echo $slug; ?>"><?php echo $label; ?></option>
                <?php endforeach; ?>
                </select></li>
            </ul>
            <ul>
                <li><?php _e("Garage Location:", 'floorplans'); ?> <select name="garage_location"><option value="all">All</option><option value="under">Under</option><option value="main">Main Level</option></select></li>
                <li><?php _e("Optional 3rd Floor:", 'floorplans'); ?> <select name="third_floor"><option value="all">All</option><option value="1">Yes</option><option value="0">No</option></select></li>
            </ul>
            <ul>
                <li><?php _e("1st Floor Mastersuites Only:", 'floorplans'); ?> <select name="first_floor_master_suite"><option value="all">All</option><option value="1">Yes</option><option value="0">No</option></select></li>
        		<li><?php _e("Side Load Garage:", 'floorplans'); ?> <select name="sideload_garage"><option value="all">All</option><option value="1">Yes</option><option value="0">No</option></select></li>
        	</ul>
            <input type="button" value="Filter Floorplans" class="filter_button" />
        </div>
    </div>
    <script type="text/javascript">
        var pagebox = jQuery('#floorplans_pagination');
        var sorterbox = jQuery('#floorplans_sorter');
        var ajaxloader = jQuery('#ajax_loader');
        var params = {
            action: 'fp_floorplan_overview_pagination',
            ajax_call:'true',
            <?php
            $data = explode('&',$query);
            foreach($data as $attr => $value ){
                if ($value == '')continue;
                $value_data = explode('=',$value);
                if($value_data[0]=='pagi' || $value_data[0] == 'pagination') continue;
                echo "$value_data[0]: '$value_data[1]'";
                if(end($data) !== $value) echo ',';
            } ?>
        };
        function getfloorplans() {
            ajaxloader.show();
            jQuery.ajax({
                url: '<?php echo admin_url('admin-ajax.php'); ?>',
                data: params,
                success: function(data) {
					//alert("sdf");
                    ajaxloader.hide();
                    if(data.indexOf('fp_nothing_found')){
                        jQuery('.fp_row_view').html(data);
						var floorplans = jQuery(data).find('.floorplan_div');
						//alert(floorplans.length);
                    }else{
                        var floorplans = jQuery(data).find('.floorplan_div');
                        jQuery('.fp_row_view').html('');
                        if(floorplans.length > 0) {
                            floorplans.each(function(i, el){
                                jQuery('.fp_row_view').append(el);
                            });
                        }
                    }
                }
            });
        }
		
		function get_filters_string() {
			var filter_div = jQuery('#floorplan_filters');
			if (!filter_div.is(":visible")) return "";
			else {
				var filter_string = "";
				var filters = filter_div.find("select");
				filters.each(function() {
					filter_string = filter_string + "&" + jQuery(this).attr("name") + "=" + jQuery(this).attr("value");
				});
				return filter_string.substr(1);
			}
		}
		
        if(sorterbox.length > 0) {
            sorterbox.find('#sort_by').change(function(){
                params.sort_by = jQuery(this).val();
                getfloorplans();
            });
            sorterbox.find('#sort_order').click(function(){
                var el = jQuery(this);
                if (el.hasClass('ASC')) {
                    el.removeClass('ASC');
                    el.addClass('DESC');
                    params.sort_order = 'DESC';
                } else {
                    el.removeClass('DESC');
                    el.addClass('ASC');
                    params.sort_order = 'ASC';
                }
				params.filters = get_filters_string();
                getfloorplans();
            });
        }
		make_pagination();
        if(pagebox.length > 0) {
            params.pagination = true;
            params.starting_row = '<?php echo $offset; ?>';
            params.per_page = '<?php echo $per_page; ?>';
            pagebox.find('a.nav').click(function(){
                var nav = jQuery(this);
                if(nav.hasClass('disabled'))
                    return false;
                var selected_page = pagebox.find('li a.page_button.selected');
                if(nav.hasClass('prev')) {
                    var prevEl = selected_page.parent().prev();
                    prevEl.children().click();
                } else {
                    var nextEl = selected_page.parent().next();
                    nextEl.children().click();
                }
                return false;
            });
            pagebox.find('li a.page_button').click(function(){
                var current_page = jQuery(this);
                if(current_page.hasClass('selected'))
                    return false;
                var pages = pagebox.find('li a.page_button');
                pages.each(function(i, el){
                    jQuery(el).removeClass('selected');
                });
                current_page.addClass('selected');
                if(current_page.parent().next().length == 0) {
                    pagebox.find('a.nav.next').removeClass('enabled');
                    pagebox.find('a.nav.next').addClass('disabled');
                } else {
                    pagebox.find('a.nav.next').removeClass('disabled');
                    pagebox.find('a.nav.next').addClass('enabled');
                }
                if(current_page.parent().prev().length == 0) {
                    pagebox.find('a.nav.prev').removeClass('enabled');
                    pagebox.find('a.nav.prev').addClass('disabled');
                } else {
                    pagebox.find('a.nav.prev').removeClass('disabled');
                    pagebox.find('a.nav.prev').addClass('enabled');
                }
                params.starting_row = current_page.attr('id');
				params.filters = get_filters_string();
                getfloorplans();
                return false;
            });
        }
		var filter_button = jQuery("input.filter_button");
		filter_button.click(function() {
			params.filters = get_filters_string();
			getfloorplans();
			make_pagination();
            return false;
		});
    </script>