<?php
/**
 * Property Default Template for Single Property View
 *
 * Overwrite by creating your own in the theme directory called either:
 * property.php
 * or add the property type to the end to customize further, example:
 * property-building.php or property-floorplan.php, etc.
 *
 * By default the system will look for file with property type suffix first, 
 * if none found, will default to: property.php
 *
 * Copyright 2010 Andy Potanin <andy.potanin@twincitiestech.com>
 *
 * @version 1.3
 * @author Andy Potanin <andy.potnain@twincitiestech.com>
 * @package WP-Property
*/

global $floorplans;

// Uncomment to disable fancybox script being loaded on this page
//wp_deregister_script('jquery-fancybox');
//wp_deregister_script('jquery-fancybox-css');
?>

<?php get_header(); ?>
<?php the_post(); ?>
  	
	
	<div id="container" class="floorplan_sidebar">
		<div id="content" role="main" class="floorplan_content">
			<div id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
		
			
			<div class="building_title_wrapper">
				<h1 class="floorplan-title entry-title"><?php the_title(); ?></h1>
			</div>
		
			<?php floorplan_slideshow(); ?>
   
	
			<div class="entry-content">
				<?php the_content(); ?>
                
                <?php
					if ( is_active_sidebar( 'fp_floorplan_top_row' ) ) : ?>
				
						<div id="fp_floorplan_top_row" class="widget-area">
							<ul>
								<?php dynamic_sidebar( 'fp_floorplan_top_row' ); ?>
							</ul>
						</div><!-- #primary .widget-area -->
				
				<?php endif; ?>
					
                
                <?php
					if ( is_active_sidebar( 'fp_floorplan_bottom_row' ) ) : ?>
				
						<div id="fp_floorplan_bottom_row" class="widget-area">
							<ul>
								<?php dynamic_sidebar( 'fp_floorplan_bottom_row' ); ?>
							</ul>
						</div><!-- #primary .widget-area -->
				
				<?php endif; ?>
                

					 
			</div><!-- .entry-content -->
		</div><!-- #post-## -->

		</div><!-- #content -->
	</div><!-- #container -->	


<?php
	// Primary property-type sidebar.
	if ( is_active_sidebar( 'fp_floorplan_right_sidebar' ) ) : ?>

		<div id="primary" class="widget-area fp_floorplan_sidebar" role="complementary">
			<ul class="xoxo">
				<?php dynamic_sidebar( 'fp_floorplan_right_sidebar' ); ?>
			</ul>
		</div><!-- #primary .widget-area -->

<?php endif; ?>

 
 <?php //get_footer(); ?>
